/* portab.h: (C) 2007 Peter Cordes <peter@cordes.ca> Dalhousie University.
 *
 * stuff which can take advantage of GNU C, or other system-specific goodies,
 * with fallbacks to our own versions.
 */

// backward compat for old gcc, from gcc info page.
#if __STDC_VERSION__ < 199901L
# if __GNUC__ >= 2
#  define __func__ __FUNCTION__
# else
#  define __func__ "<unknown>"
# endif
#endif

#ifndef max
#ifdef __GNUC__
/* See the gcc info page, (gcc)Typeof */
/* this is kind of pointless, because using an expression with side-effects
 * in an arg to max() will make the program non-portable */
# define max(a,b) ({ typeof (a) _a = (a); typeof (b) _b = (b); _a > _b ? _a : _b; })
# define min(a,b) ({ typeof (a) _a = (a); typeof (b) _b = (b); _a < _b ? _a : _b; })
#else
# define max(a, b) ((a) > (b) ? (a) : (b))
# define min(a, b) ((a) < (b) ? (a) : (b))
#endif
#endif

#ifndef __GLIBC__
int asprintf(char **strp, const char *format, ...);
#endif
